unit mainform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdIOHandler, IdIOHandlerSocket, IdIOHandlerStack, IdSSL,
  IdSSLOpenSSL, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdExplicitTLSClientServerBase, IdFTP, ZAbstractConnection, ZConnection, DB,
  ZAbstractRODataset, ZAbstractDataset, ZDataset, ExtCtrls, Buttons, StdCtrls,
  Mask, ToolEdit, jpeg, ComCtrls, Grids, DBGrids, RXDBCtrl, DateUtils, IniFiles,
  ShlObj, ShellAPI, strutils, Spin, DBCtrls;

type
     TMainTable       = Record
       Data_Host,
       Data_Protocol,
       Data_Database,
       Data_User,
       Data_Password,
       Data_Port: String;

       Ftp_Host,
       Ftp_User,
       Ftp_Password,
       Ftp_port,
       Ftp_UseTSL,
       Ftp_ReadTimeout: String;
     End;

  TForm1 = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Label3: TLabel;
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    ZQuery1: TZQuery;
    ZConnection1: TZConnection;
    IdFTP1: TIdFTP;
    IdSSLIOHandlerSocketOpenSSL1: TIdSSLIOHandlerSocketOpenSSL;
    NaploMemo: TMemo;
    BitBtn1: TBitBtn;
    DataSource1: TDataSource;
    ZQuery1do_id: TStringField;
    ZQuery1dopos_id: TStringField;
    ZQuery1do_co: TStringField;
    ZQuery1docust_type: TStringField;
    ZQuery1inv_line_pos: TStringField;
    ZQuery1sku: TStringField;
    ZQuery1ean: TStringField;
    ZQuery1qty: TFloatField;
    ZQuery1uom: TStringField;
    ZQuery1docust_post: TStringField;
    ZQuery2: TZQuery;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    RxDBGrid1: TRxDBGrid;
    DataSource2: TDataSource;
    RxDBGrid2: TRxDBGrid;
    ZQuery2do_id: TStringField;
    ZQuery2do_co: TStringField;
    ZQuery2docust_type: TStringField;
    ZQuery2inv_no: TStringField;
    ZQuery2inv_line_pos: TStringField;
    ZQuery2sku: TStringField;
    ZQuery2ean: TStringField;
    ZQuery2qty: TFloatField;
    ZQuery2uom: TStringField;
    ZQuery1ecom: TStringField;
    ZQuery3: TZQuery;
    ZQuery3do_id: TStringField;
    ZQuery3dopos_id: TStringField;
    ZQuery3do_co: TStringField;
    ZQuery3sku: TStringField;
    ZQuery3ean: TStringField;
    ZQuery3qty: TFloatField;
    ZQuery3uom: TStringField;
    ZQuery3rep_date: TStringField;
    DataSource3: TDataSource;
    RxDBGrid3: TRxDBGrid;
    ZQuery3_min_keszlet: TStringField;
    ZQuery4: TZQuery;
    ZQuery4kod: TIntegerField;
    ZQuery4do_id: TStringField;
    ZQuery4dopos_id: TStringField;
    ZQuery4do_co: TStringField;
    ZQuery4sku: TStringField;
    ZQuery4ean: TStringField;
    ZQuery4qty: TFloatField;
    ZQuery4uom: TStringField;
    ZQuery4rep_date: TStringField;
    ZQuery4_min_keszlet: TFloatField;
    ZQuery4_qty: TFloatField;
    ZQuery4_sor2: TStringField;
    ZQuery4_nev: TStringField;
    ZQuery3_sor2: TStringField;
    ZQuery3_nev: TStringField;
    Panel2: TPanel;
    Edit_kereses: TEdit;
    ZQuery1inv_no: TStringField;
    ZQuery1inv_date: TStringField;
    ZQuery2inv_date: TStringField;
    ZQuery2ind_tax: TStringField;
    SpinEdit_ev: TSpinEdit;
    SpinEdit_ho: TSpinEdit;
    TabSheet4: TTabSheet;
    ZQuery5: TZQuery;
    ZQuery5kod: TIntegerField;
    ZQuery5adoszam: TStringField;
    ZQuery5nev: TStringField;
    RxDBGrid4: TRxDBGrid;
    DataSource4: TDataSource;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);

    function leftpos(str: String; substring: String; Count: Integer): Integer;
    function ReadIniFile : boolean;
    function GetSpecialFolderPath(CallerHandle: THandle; CSIDL: Integer): PChar;
    procedure ZQuery1BeforeOpen(DataSet: TDataSet);
    procedure ZQuery2BeforeOpen(DataSet: TDataSet);
    procedure ZQuery3BeforeOpen(DataSet: TDataSet);
    Function ExecSQL(SQLText: String): Boolean;
    procedure CopyData(SourceData, DestinationData: TDataSet; kod_mezot_masol: Integer);
    procedure RxDBGrid3KeyPress(Sender: TObject; var Key: Char);
    function GyorsKereso(Key: Char; Form: TForm; DataTable: TDataSet; OrderField: String): Boolean;
    procedure RxDBGrid3DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Frissit;
    function WindowsTemp : String;
    procedure ZQuery4BeforeOpen(DataSet: TDataSet);
    procedure RxDBGrid3TitleBtnClick(Sender: TObject; ACol: Integer;
      Field: TField);
    procedure RxDBGrid3GetBtnParams(Sender: TObject; Field: TField;
      AFont: TFont; var Background: TColor; var SortMarker: TSortMarker;
      IsDown: Boolean);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
     InitDirectory: String;
     PGresDatefmtSettings: TFormatSettings;
     SchDatefmtSettings: TFormatSettings;
     autostart: Boolean;
     MainTable: TMainTable;

     OrderField: String;
     OrderDirection: TSortMarker;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses kereses, progress;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
   GetLocaleFormatSettings(LOCALE_SYSTEM_DEFAULT, PGresDatefmtSettings);
   PGresDatefmtSettings.ShortDateFormat := 'yyyy-mm-dd';
   PGresDatefmtSettings.DateSeparator := '-';
   PGresDatefmtSettings.DecimalSeparator := '.';

   GetLocaleFormatSettings(LOCALE_SYSTEM_DEFAULT, SchDatefmtSettings);
   SchDatefmtSettings.ShortDateFormat := 'dd. mm. yyyy';
   SchDatefmtSettings.DateSeparator := '.';
   SchDatefmtSettings.DecimalSeparator := '.';

end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
   if (Key = #13) then
   begin
      key := #0;
      if visible then
      begin
         if (Edit_kereses.Focused) then
            Frissit
         else
            Perform (CM_DialogKey, VK_TAB,0);
      end;
   end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
   i: Integer;
begin
   NaploMemo.Lines.Clear;
   InitDirectory := ExtractFilePath(Application.EXEName);
   SpinEdit_ev.Value := YearOf(NOW-15);
   SpinEdit_ho.Value := MonthOf(NOW-15);

   ZQuery5.Close;
   ZQuery5.Open;

   RxDBGrid3.Columns.State := csDefault;
   Edit_kereses.Text := '';

//         OrderDirection := smUp
   OrderDirection := smDown;
   OrderField := 'sku';

   PageControl1.ActivePage := TabSheet1;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  f,res  : TextFile;
  textline, adoszamkodolt: String;
  datum: TDateTime;
  i: integer;
begin

  ReadIniFile;

  ZConnection1.Disconnect;
  ZConnection1.LibraryLocation := '';
  ZConnection1.Database := MainTable.Data_Database;
  ZConnection1.HostName := MainTable.Data_Host;
  ZConnection1.Protocol := MainTable.Data_Protocol;
  ZConnection1.User     := MainTable.Data_User;
  ZConnection1.Password := MainTable.Data_Password;
  ZConnection1.Port     := StrToIntDef(MainTable.Data_Port,5432);
  ZConnection1.Connect;

  Progress_Form.Label_Fejresz.Caption := '"Sell Out" elkszts';
  Progress_Form.DuckInit(2);
  Progress_Form.Show;
  ZQuery1.Close;
  ZQuery1.Open;
  Progress_Form.DuckRepaint(2);

  Progress_Form.Label_Fejresz.Caption := '"Indirect report" elkszts';
  Progress_Form.DuckInit(2);
  ZQuery2.Close;
  ZQuery2.Open;
  Progress_Form.DuckRepaint(2);

  Edit_kereses.Text := '';
  if (Application.MessageBox('Fellrjam az utols kszletlegyjtst?', 'Kszlet tbla trls jvhagysa', MB_YESNO + MB_DEFBUTTON1) = IDYES) then
  begin
     ExecSQL('DELETE FROM _schneider_inventory;');

     Progress_Form.Label_Fejresz.Caption := '"Inventory" elkszts';
     Progress_Form.DuckInit(2);
     ZQuery3.Close;
     ZQuery3.Open;
     Progress_Form.DuckRepaint(2);
     Application.ProcessMessages;
  // trlhet?
     Progress_Form.Label_Fejresz.Caption := '"Inventory" tbla ltrehozsa';
     Progress_Form.DuckInit(ZQuery3.RecordCount);
     Application.ProcessMessages;

     ZQuery4.Close;
     ZQuery4.Open;

     ZQuery3.First;
     while not ZQuery3.Eof do
     begin
        ZQuery4.Insert;
        CopyData(ZQuery3, ZQuery4, 0);
        ZQuery4.FieldByName('_qty').AsFloat := ZQuery3.FieldByName('qty').AsFloat;
        ZQuery4.FieldByName('_min_keszlet').AsFloat := StrToFloatDef(ZQuery3.FieldByName('_min_keszlet').AsString,0);
        ZQuery4.Post;

        Progress_Form.DuckRepaint(ZQuery3.RecNo);
        Application.ProcessMessages;
        
        ZQuery3.Next;
     end;
  end;

  ZQuery4.Close;
  ZQuery4.Open;

  for i := 0 to RxDBGrid3.Columns.Count - 1 do
     RxDBGrid3.Columns[i].ReadOnly := (RxDBGrid3.Columns[i].FieldName <> 'qty');

  Progress_Form.Hide;

   ZQuery5.Close;
   ZQuery5.Open;  


end;

procedure TForm1.ZQuery1BeforeOpen(DataSet: TDataSet);
begin
   ZQuery1.ParamByName('datum1').AsDate := StartOfTheMonth(Encodedate(SpinEdit_ev.Value, SpinEdit_ho.Value,1));
   ZQuery1.ParamByName('datum2').AsDate := EndOfTheMonth(Encodedate(SpinEdit_ev.Value, SpinEdit_ho.Value,1));
end;

procedure TForm1.ZQuery2BeforeOpen(DataSet: TDataSet);
begin
   ZQuery2.ParamByName('datum1').AsDate := StartOfTheMonth(Encodedate(SpinEdit_ev.Value, SpinEdit_ho.Value,1));
   ZQuery2.ParamByName('datum2').AsDate := EndOfTheMonth(Encodedate(SpinEdit_ev.Value, SpinEdit_ho.Value,1));
end;

procedure TForm1.ZQuery3BeforeOpen(DataSet: TDataSet);
begin
   ZQuery3.ParamByName('datum2').AsDate := EndOfTheMonth(Encodedate(SpinEdit_ev.Value, SpinEdit_ho.Value,1));
   ZQuery3.ParamByName('raktar').AsInteger := 1;
   ZQuery3.ParamByName('raktar_angol').AsString :=
      rightstr('0'+IntTOStr(DayOf(EndOfTheMonth(Encodedate(SpinEdit_ev.Value, SpinEdit_ho.Value,1)))),2)+
      '/'+
      rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+
      '/'+
      IntTOStr(SpinEdit_ev.Value);
end;

procedure TForm1.ZQuery4BeforeOpen(DataSet: TDataSet);
begin
   ZQuery4.SQL[5] := ' WHERE (upper(_sor2) like upper('''+Edit_kereses.Text+'%'')) or (upper(_nev) like upper('''+Edit_kereses.Text+'%'')) or (upper(sku) like upper('''+Edit_kereses.Text+'%''))';
   if OrderField <> '' then
   begin
      ZQuery4.SQL[12] := '  order by '+OrderField;
      if OrderDirection = smDown then ZQuery4.SQL[12] := ZQuery4.SQL[12] + ' DESC'
                                 else ZQuery4.SQL[12] := ZQuery4.SQL[12] + ' ASC';
   end
   else
      ZQuery4.SQL[12] := ' order by sku';
end;

function TForm1.leftpos(str: String; substring: String; Count: Integer): Integer;
var
   I, Found, Index: INteger;
begin
   Found := 0;
   for I := 1 to Length(str)-Length(substring)+1 do
   begin
      if copy(str,I,Length(substring)) = substring then
      begin
         Inc(Found);
         Index := I;
         if Found = Count then Result := Index;
      end;
   end;
end;

function TForm1.ReadIniFile : boolean;
var
   Inifile    : TIniFile;
   IniPath    : string;
   iteszt: Integer;
begin
  Result    := True;
  InitDirectory := ExtractFilePath(Application.EXEName);
  try
     IniPath := GetSpecialFolderPath(0, CSIDL_LOCAL_APPDATA)+'\Multiszolg\KerRend2007\'+StringReplace(StringReplace(InitDirectory,':','',[rfReplaceAll, rfIgnoreCase]),'\','_',[rfReplaceAll, rfIgnoreCase])+'\KerRend.ini';
     if not FileExists(IniPath) then
        IniPath := InitDirectory+'KerRend.ini';
     if FileExists(IniPath) then
     begin
         Inifile   := TIniFile.Create(IniPath);
         MainTable.Data_Host            := inifile.readstring('DataBase','Host', 'localhost');
         MainTable.Data_Database        := inifile.readstring('DataBase','Database', 'KerRend_Data');
         MainTable.Data_Protocol        := inifile.readstring('DataBase','Protocol', 'postgresql-7.3');
         MainTable.Data_User            := inifile.readstring('DataBase','User', 'KerUser');
         MainTable.Data_Password        := inifile.readstring('DataBase','Password', 'mnb456');
         MainTable.Data_Port            := inifile.readstring('DataBase','Port', '0');

         MainTable.Ftp_Host             := inifile.readstring('Ftp','Host', 'sqlsieben2.northeurope.cloudapp.azure.com');
         MainTable.Ftp_User             := inifile.readstring('Ftp','User', 'tafeKft');
         MainTable.Ftp_Password         := inifile.readstring('Ftp','Password', '77tafekft&&');
         MainTable.Ftp_port             := inifile.readstring('Ftp','Port', '990');
//         MainTable.Ftp_UseTSL           := inifile.readstring('Ftp','UseTSL', 'utUseImplicitTLS');
         MainTable.Ftp_ReadTimeout      := inifile.readstring('Ftp','ReadTimeout', '60000');

         Inifile.free;
     end;
  except
     Application.MessageBox(
         Pointer(IniPath+' fjl betltse megszakadt!'),
         'Betltsi hiba', MB_OK + MB_DEFBUTTON1);
    Result    := False;
  end;

end;

procedure TForm1.RxDBGrid3DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
begin
   RxDBGrid3.Canvas.Font.Style := [];
   If (ZQuery4.FieldByName('qty').AsFloat = 0) then
      RxDBGrid3.Canvas.Font.Style := RxDBGrid3.Canvas.Font.Style + [fsStrikeOut];
   If (ZQuery4.FieldByName('qty').AsFloat <> ZQuery4.FieldByName('_qty').AsFloat) then
      RxDBGrid3.Canvas.Font.Style := RxDBGrid3.Canvas.Font.Style + [fsBold];

   if (not(gdSelected in State)) and (not(gdFocused in State)) then
   begin
      If (ZQuery4.FieldByName('qty').AsFloat < ZQuery4.FieldByName('_min_keszlet').AsFloat) then
         RxDBGrid3.Canvas.Brush.Color := clRed;

      If (ZQuery4.FieldByName('_min_keszlet').AsFloat = 0) then
         RxDBGrid3.Canvas.Brush.Color := clYellow;

      If (ZQuery4.FieldByName('qty').AsFloat < 0) then
         RxDBGrid3.Canvas.Brush.Color := clFuchsia;
   end;

   RxDBGrid3.DefaultDrawDataCell(Rect, Field, State);
end;

procedure TForm1.RxDBGrid3GetBtnParams(Sender: TObject; Field: TField;
  AFont: TFont; var Background: TColor; var SortMarker: TSortMarker;
  IsDown: Boolean);
begin
   if Field.FieldName = OrderField then SortMarker := OrderDirection;
end;

procedure TForm1.RxDBGrid3KeyPress(Sender: TObject; var Key: Char);
begin
//   GyorsKereso(Key, Self, ZQuery4, 'sku');
end;

procedure TForm1.RxDBGrid3TitleBtnClick(Sender: TObject; ACol: Integer;
  Field: TField);
var
   NewOrderField: String;
begin
   if (Field as TField).Origin <> '' then NewOrderField := (Field as TField).Origin else NewOrderField := (Field as TField).FieldName;
   if NewOrderField = OrderField then
      if OrderDirection = smDown then OrderDirection := smUp else OrderDirection := smDown;
   OrderField := NewOrderField;
   Frissit;
end;

function TForm1.GetSpecialFolderPath(CallerHandle: THandle; CSIDL: Integer): PChar;
var
  exInfo: TShellExecuteInfo;
  Buf: PChar;
begin
  // initialize all fields to 0
  FillChar(exInfo, SizeOf(exInfo), 0);
  with exInfo do
  begin
    cbSize := SizeOf(exInfo); 
    fMask  := SEE_MASK_FLAG_DDEWAIT or SEE_MASK_IDLIST;
    Wnd    := CallerHandle;
    nShow  := SW_SHOWNORMAL;
    Buf    := StrAlloc(MAX_PATH);
    SHGetSpecialFolderPath(wnd, Buf, CSIDL, True);
    Result := Buf;
  end;
end;

Function TForm1.ExecSQL(SQLText: String): Boolean;
var
   LocalSQL: TZQuery;
begin
   Result := False;
   begin
      try
         LocalSQL := TZQuery.Create(self);
         with (LocalSQL) do
         begin
            Connection := ZConnection1;
            PingServerBeforeOpen := false;
            Name := 'ExecSQLSQL'+IntToStr(Random(2147483647));
            LocalSQL.SQL.Add(SQLText);
//            PingServerAndReconnect;
            ExecSQL;
            Result := True;
         end;
      finally
         LocalSQL.Cancel;
         LocalSQL.Free;
      end;
   end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  f,res  : TextFile;
  textline, adoszamkodolt: String;
  datum: TDateTime;
begin

   PageControl1.ActivePage := TabSheet1;
     ZQuery1.First;
     AssignFile(res,InitDirectory+ '\Export\' + '1000012849_SellOut_'+IntTOStr(SpinEdit_ev.Value)+'_'+rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+'.csv');
     ReWrite(res);
     Writeln(res,'DO_ID;DOPOS_ID;DO_CO;DOCUST_POST;DOCUST_TYPE;INV_DATE;INV_NO;INV_LINE_POS;SKU;EAN;QTY;UOM;E-COM');
     While not ZQuery1.eof do
     begin
        Writeln(res,ZQuery1.FieldByName('DO_ID').AsString+';'+ZQuery1.FieldByName('DOPOS_ID').AsString+';'+
         ZQuery1.FieldByName('DO_CO').AsString+';'+ZQuery1.FieldByName('DOCUST_POST').AsString+';'+
         ZQuery1.FieldByName('DOCUST_TYPE').AsString+';'+ZQuery1.FieldByName('INV_DATE').AsString+';'+
         ZQuery1.FieldByName('INV_NO').AsString+';'+ZQuery1.FieldByName('INV_LINE_POS').AsString+';'+
         ZQuery1.FieldByName('SKU').AsString+';'+ZQuery1.FieldByName('EAN').AsString+';'+
         ZQuery1.FieldByName('QTY').AsString+';'+ZQuery1.FieldByName('UOM').AsString+';'+
         ZQuery1.FieldByName('E-COM').AsString);

        ZQuery1.Next;
     end;
     CloseFile(res);

   PageControl1.ActivePage := TabSheet2;
     ZQuery2.First;
     AssignFile(res,InitDirectory+ '\Export\' + '1000012849_Indirect_'+IntTOStr(SpinEdit_ev.Value)+'_'+rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+'.csv');
     ReWrite(res);
     Writeln(res,'DO_ID;DO_CO;IND_TAX;DOCUST_TYPE;INV_DATE;INV_NO;INV_LINE_POS;SKU;EAN;QTY;UOM');
     While not ZQuery2.eof do
     begin
        Writeln(res,ZQuery2.FieldByName('DO_ID').AsString+';'+
         ZQuery2.FieldByName('DO_CO').AsString+';'+ZQuery2.FieldByName('IND_TAX').AsString+';'+
         ZQuery2.FieldByName('DOCUST_TYPE').AsString+';'+ZQuery2.FieldByName('INV_DATE').AsString+';'+
         ZQuery2.FieldByName('INV_NO').AsString+';'+ZQuery2.FieldByName('INV_LINE_POS').AsString+';'+
         ZQuery2.FieldByName('SKU').AsString+';'+ZQuery2.FieldByName('EAN').AsString+';'+
         ZQuery2.FieldByName('QTY').AsString+';'+ZQuery2.FieldByName('UOM').AsString);

        ZQuery2.Next;
     end;
     CloseFile(res);

   PageControl1.ActivePage := TabSheet3;
     ZQuery4.First;
     AssignFile(res,InitDirectory+ '\Export\' + '1000012849_Inventory_'+IntTOStr(SpinEdit_ev.Value)+'_'+rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+'.csv');
     ReWrite(res);
     Writeln(res,'DO_ID;DOPOS_ID;DO_CO;SKU;EAN;QTY;UOM;REP_DATE');
     While not ZQuery4.eof do
     begin
        Writeln(res,ZQuery4.FieldByName('DO_ID').AsString+';'+ZQuery4.FieldByName('DOPOS_ID').AsString+';'+
         ZQuery4.FieldByName('DO_CO').AsString+';'+
         ZQuery4.FieldByName('SKU').AsString+';'+ZQuery4.FieldByName('EAN').AsString+';'+
         ZQuery4.FieldByName('QTY').AsString+';'+ZQuery4.FieldByName('UOM').AsString+';'+
         ZQuery4.FieldByName('REP_DATE').AsString);

        ZQuery4.Next;
     end;
     CloseFile(res);


{  CopyFile(pointer(InitDirectory+'DLL_\ssleay32.dll'), pointer(InitDirectory+'ssleay32.dll'), false);
  CopyFile(pointer(InitDirectory+'DLL_\libeay32.dll'), pointer(InitDirectory+'libeay32.dll'), false);

  IdFTP1.Disconnect;
  IdFTP1.Host := MainTable.Ftp_Host;
  IdFTP1.Username := MainTable.Ftp_User;
  IdFTP1.Password := MainTable.Ftp_Password;
  IdFTP1.Port := StrToIntDef(MainTable.Ftp_port,990);
  IdFTP1.ReadTimeout := StrToIntDef(MainTable.Ftp_ReadTimeout,60000);

     IdFTP1.Passive := True;
     try
       IdFTP1.Connect;
       try
         IdFTP1.Put(InitDirectory+ '\Export\' + '1000012849_SellOut_'+IntTOStr(SpinEdit_ev.Value)+'_'+rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+'.csv',
                  '/Input/'+ '1000012849_SellOut_'+IntTOStr(SpinEdit_ev.Value)+'_'+rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+'.csv', False);
         IdFTP1.Put(InitDirectory+ '\Export\' + '1000012849_Indirect_'+IntTOStr(SpinEdit_ev.Value)+'_'+rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+'.csv',
                  '/Input/'+ '1000012849_Indirect_'+IntTOStr(SpinEdit_ev.Value)+'_'+rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+'.csv', False);
         IdFTP1.Put(InitDirectory+ '\Export\' + '1000012849_Inventory_'+IntTOStr(SpinEdit_ev.Value)+'_'+rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+'.csv',
                  '/Input/'+ '1000012849_Inventory_'+IntTOStr(SpinEdit_ev.Value)+'_'+rightstr('0'+IntTOStr(SpinEdit_ho.Value),2)+'.csv', False);
       finally
         IdFTP1.Disconnect;
       end;
     except
       ShowMessage('Fletltsi hiba!');
     end;

  IdFTP1.Disconnect;
  DeleteFile(InitDirectory+'ssleay32.dll');
  DeleteFile(InitDirectory+'libeay32.dll');}

{

  // fontos installlni a postgresql adatbzisra, a CREATE EXTENSION pgcrypto; paranccsal
  datum := DateEdit1.Date;
  repeat
     NaploMemo.Lines.Add('Forgalomfjl sszelltsa ('+DateToStr(datum)+')');

     ZQuery1.Close;
     ZQuery1.SQL.Clear;
     ZQuery1.SQL.Add('SELECT (SELECT nev1 FROM tulajdonos LIMIT 1) as partner_nev,'+
    '     bf.partner_adoszam as adoszam,'+
//    '     UPPER(encode(digest(bf.partner_adoszam, ''sha256''), ''hex'')) as adoszam,'+
    '     MAX(rmf.bizonylatszam) as bizonylatszam, MAX(rmf.kelte) as kelte,'+
    '     (SELECT iszam||'' ''||telepules||'' ''||utca FROM tulajdonos LIMIT 1) as cim,'+
    '     t.sor3 as termek_kod, SUM(rm.mennyiseg) as mennyiseg'+
    '  FROM raktar_mozgas_fej rmf'+
    '  INNER JOIN raktar_mozgas rm ON rmf.kod = rm.fej_kod'+
    '  INNER JOIN tetel t ON rm.tetel_kod = t.kod'+
    '  INNER JOIN bizonylatszoveg_fej bf ON bf.fej_kod = rmf.kod'+
    '  LEFT JOIN _myschneider_customers mc ON mc.adoszam_kodolt = UPPER(ENCODE(DIGEST(bf.partner_adoszam, ''sha256''), ''hex''))'+
    '  WHERE (not(mc.kod is null))'+
    '   AND (rmf.kelte = ''' + DateToStr(datum, PGresDatefmtSettings) + ''')'+
    '   AND (rmf.bizonylat_fajta in (5))'+
    '   AND (rmf.forras_raktar_kod <> 0)'+
    '   AND (t.fajta1 = 18)'+
    '  GROUP BY rmf.partner_kod, bf.partner_adoszam, t.kod'+
    '  HAVING SUM(rm.mennyiseg) <> 0'+
    '  ORDER BY bf.partner_adoszam, t.sor2');

     ZQuery1.Open;
     AssignFile(res,InitDirectory + 'Export_'+DateToStr(datum, PGresDatefmtSettings)+'.csv');
     ReWrite(res);
     While not ZQuery1.eof do
     begin
        Writeln(res,''''+'TA-FE KFT.'+''','''+ZQuery1.FieldByName('adoszam').AsString+''','''+
         ZQuery1.FieldByName('bizonylatszam').AsString+''','+DateToStr(ZQuery1.FieldByName('kelte').AsDateTime, SchDatefmtSettings)+','''+
         'TA-FE KFT. SZENTES'+''','+'1,'+''''+ZQuery1.FieldByName('termek_kod').AsString+''','+ZQuery1.FieldByName('mennyiseg').AsString);

        NaploMemo.Lines.Text := NaploMemo.Lines.Text + '.';
        ZQuery1.Next;
     end;
     CloseFile(res);
     NaploMemo.Lines.Add('Ok.');

     NaploMemo.Lines.Add('Ftp kapcsolat ltestse: '+IdFTP1.Host);
     IdFTP1.Passive := True;
     try
       IdFTP1.Connect;
       NaploMemo.Lines.Add('Ok.');
       try
         NaploMemo.Lines.Add('Export_'+DateToStr(datum, PGresDatefmtSettings)+'.csv feltltse.');
         IdFTP1.Put(InitDirectory + 'Export_'+DateToStr(datum, PGresDatefmtSettings)+'.csv', '/Import/'+ 'Export_'+DateToStr(datum, PGresDatefmtSettings)+'.csv', False);
         NaploMemo.Lines.Add('Ok.');
       finally
         IdFTP1.Disconnect;
       end;
     except
       NaploMemo.Lines.Add('Feltlts hiba.');
       Break;
     end;

     datum := datum + 1;
  until (datum > DateEdit2.Date);

  ZConnection1.Disconnect ;

  NaploMemo.Lines.Add('');
  NaploMemo.Lines.Add('Ksz.');

  SpeedButton1.Enabled := True;
  DateEdit1.Enabled := True;
  DateEdit2.Enabled := True;       }

end;

procedure TForm1.CopyData(SourceData, DestinationData: TDataSet; kod_mezot_masol: Integer);
var
   i, j: integer;
begin
   for i := 0 to SourceData.FieldCount - 1 do
   begin
      if LowerCase(SourceData.Fields[i].FieldName) = 'kod' then
         if DestinationData.FindField('kod') <> nil then
            DestinationData.FieldByName('kod').Required := False;

      if (LowerCase(SourceData.Fields[i].FieldName) <> '_min_keszlet') then
      if (LowerCase(SourceData.Fields[i].FieldName) <> 'kod') or ((LowerCase(SourceData.Fields[i].FieldName) = 'kod') and (kod_mezot_masol = 1)) then
      begin
         if DestinationData.FindField(SourceData.Fields[i].FieldName) <> nil then
         begin
            if DestinationData.FieldByName(SourceData.Fields[i].FieldName).AsVariant <> SourceData.Fields[i].AsVariant then
            begin
               DestinationData.FieldByName(SourceData.Fields[i].FieldName).AsVariant := SourceData.Fields[i].AsVariant;
            end;
         end;
      end;
   end;
end;

function TForm1.GyorsKereso(Key: Char; Form: TForm; DataTable: TDataSet; OrderField: String): Boolean;
begin
   Result := False;
   if (((Key >= '0') and (Key <= '9')) or ((Key >= 'A') and (Key <= 'z')) or ((Key >= '') and (Key <= ''))) then
   begin
      KeresesForm.Edit_kereses.Text := Key;
      KeresesForm.Left := Form.Left + (Form.Width div 2) - (KeresesForm.Width div 2);
      KeresesForm.Top := Form.Top + (Form.Height div 2) - (KeresesForm.Height div 2);
      if KeresesForm.ShowModal = mrOK then
      begin
         (DataTable as TDataSet).Locate(OrderField,KeresesForm.Edit_kereses.Text,[loCaseInsensitive,loPartialKey]);
         if (DataTable as TDataSet).FieldByName(OrderField).AsString = KeresesForm.Edit_kereses.Text then Result := True;
      end;
   end;
end;

procedure TForm1.Frissit;
var
   Oldkod: Integer;
begin
   Oldkod := ZQuery4.FieldByName('kod').AsInteger;
   ZQuery4.Close;
   ZQuery4.Open;
   ZQuery4.Locate('kod', Oldkod, []);
end;

function TForm1.WindowsTemp : String;
var
  Buffer : Array[0..Max_path] of char;
begin
  FillChar(Buffer,Max_Path + 1, 0);
  GetTempPath(Max_path, Buffer);
  Result := String(Buffer);
  if Result[Length(Result)] <> '\' then Result := Result + '\';
  if (not(DirectoryExists(Result))) then Result := 'C:\';
  Result := Result+ExtractFileName(ChangeFileExt(Application.ExeName, '.TMP'))+'\';
  if (not(DirectoryExists(Result))) then CreateDir(Result);
end;

end.

